﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections.Generic;

public class HealthManager : MonoBehaviour
{
    public GameObject healthPrefab;
    public RectTransform healthContainer;

    public Color colorEnabled = Color.blue, colorDisabled = Color.gray;

    private List<Image> healthPieces = new List<Image>();

    private int _maxHealth = 0;
    public int maxHealth
    {
        get { return _maxHealth; }
        set
        {
            if (value == _maxHealth) return;
            if (value < 0) return;

            healthContainer.Genocide();
            healthPieces.Clear();

            for (int i = 0; i < value; i++)
            {
                GameObject gO = healthContainer.gameObject.PrefabInstantiateAsChild(healthPrefab, true);
                healthPieces.Add(gO.AddComponentIfNotExists<Image>());
            }

            _maxHealth = value;
        }
    }

    private int _health = 0;
    public int health
    {
        get { return _health; }
        set
        {
            if (value == _health) return;
            
            for (int i = 0; i < maxHealth; i++)
                if (i < healthPieces.Count)
                    healthPieces[i].color = value > i ? colorEnabled : colorDisabled;

            _health = value;
        }
    }
}