﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using UniRx;

public class LaserController : MonoBehaviour {

	private Player player;

	public GameObject laserPrefab;


	public void Initialize( Player player)
	{
		this.player = player;
	}
    public void IMaFirinMyLazor(Transform muzzlePoint, Pitch pitch, float power, Potions potion){

        if (!muzzlePoint || power <= 0) return;

		GameObject laserObj = GameObject.Instantiate( laserPrefab );
		laserObj.transform.position = muzzlePoint.position;
		laserObj.transform.rotation = Quaternion.identity * muzzlePoint.rotation;

        Transform particle = laserObj.gameObject.ResourceInstantiateAsChild_GameObject(potion + "Trail").transform;
        particle.GetComponent<TrailRenderer>().widthMultiplier *= power.RetargetedFrom_01(0.5f, 1);
        particle.localRotation = Quaternion.Euler(Vector3.up * 90);
        particle.localPosition = Vector3.zero;

		LaserLogic logic = laserObj.GetComponent<LaserLogic>();
		logic.power = power;
		logic.player = player;
        logic.waveType = potion;
        logic.pitch = pitch;
        logic.effectsTransform = particle;
	}
}
