﻿using UnityEngine;
using System.Collections;

public class LightAnimation : PropAnimation {

    public Vector2 flunctuationPercentileMinMax = Vector2.one;
    public Color colorA = Color.white, colorB = Color.white;

    public Light haloLight; 

    Light l;
    float initRange;
    float initHaloRange;

    float flunctuationPercentile;

    protected override void Initialize()
    {
        l = GetComponent<Light>();
        initRange = l.range;

        flunctuationPercentile = flunctuationPercentileMinMax.RandomBetween();

        if (haloLight)
            initHaloRange = haloLight.range;
    }

    // Update is called once per frame
    protected override void Interpolate(float t)
    { 
        l.range = Mathf.Lerp(initRange * (1- flunctuationPercentile), initRange * (1 + flunctuationPercentile), t);
        l.color = The_Helper.InterpolateColor(colorA, colorB, t);

        if (haloLight)
        {
            haloLight.range = Mathf.Lerp(initHaloRange * (1 - flunctuationPercentile), initHaloRange * (1 + flunctuationPercentile), t); 
            haloLight.color = l.color;
        }
    }
}
